"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RippleEffect = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_reanimated_1 = __importStar(require("react-native-reanimated"));
exports.RippleEffect = (0, react_1.forwardRef)((_a, ref) => {
    var { duration = 500, opacity = 0.8, color = 'white', children, style, disabled } = _a, pressableProps = __rest(_a, ["duration", "opacity", "color", "children", "style", "disabled"]);
    const centerX = (0, react_native_reanimated_1.useSharedValue)(0);
    const centerY = (0, react_native_reanimated_1.useSharedValue)(0);
    const scale = (0, react_native_reanimated_1.useSharedValue)(0);
    const width = (0, react_native_reanimated_1.useSharedValue)(0);
    const height = (0, react_native_reanimated_1.useSharedValue)(0);
    const rippleOpacity = (0, react_native_reanimated_1.useSharedValue)(opacity);
    const handlePressOut = (tapEvent) => {
        if (disabled)
            return;
        scale.value = 0;
        centerX.value = tapEvent.nativeEvent.locationX;
        centerY.value = tapEvent.nativeEvent.locationY;
        rippleOpacity.value = opacity;
        (0, react_native_reanimated_1.runOnUI)(() => {
            const layout = (0, react_native_reanimated_1.measure)(ref);
            width.value = layout.width;
            height.value = layout.height;
        })();
        scale.value = (0, react_native_reanimated_1.withTiming)(1, { duration: duration });
        rippleOpacity.value = (0, react_native_reanimated_1.withTiming)(0, { duration: duration });
    };
    const animatedStyle = (0, react_native_reanimated_1.useAnimatedStyle)(() => {
        const circleRadius = width.value > height.value ? width.value : height.value * 2;
        const translateX = centerX.value - circleRadius;
        const translateY = centerY.value - circleRadius;
        return {
            width: circleRadius * 2,
            height: circleRadius * 2,
            borderRadius: circleRadius,
            opacity: rippleOpacity.value,
            zIndex: -1,
            backgroundColor: color,
            position: 'absolute',
            top: 0,
            left: 0,
            transform: [
                { translateX },
                { translateY },
                {
                    scale: scale.value,
                },
            ],
        };
    }, [centerX, centerY, width, height, rippleOpacity, scale]);
    return (react_1.default.createElement(react_native_1.Pressable, Object.assign({}, pressableProps, { onPressOut: handlePressOut }),
        react_1.default.createElement(react_native_reanimated_1.default.View, { style: [
                {
                    overflow: 'hidden',
                },
                style === null || style === void 0 ? void 0 : style.container,
            ] },
            react_1.default.createElement(react_native_reanimated_1.default.View, { style: animatedStyle }),
            children)));
});
exports.RippleEffect.displayName = 'RippleEffect';
